(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)











(* :Name: ViewPointSelect`*)



(*
ViewPointSelect` provides interactive selection of option ViewPoint based on real time rotations. It supports objects SurfaceGraphics and Graphics3D generated by functions like Plot3D, ListPlot3D, ParametricPlot3D, etc.
*)



(* :Copyright: 2006 by Yuri E. Kandrashkin *)

(* ykandras@brocku.ca *)

(* 
Permission is granted to use and distribute this package for non-commercial 
non-profit purpose except for inclusion in program collections
The file must remain intact.
*)



BeginPackage["ViewPointSelect`"]

ViewPointSelect::usage="ViewPointSelect` provides interactive selection of option ViewPoint based on real time rotations. It supports objects SurfaceGraphics and Graphics3D generated by functions like Plot3D, ListPlot3D, ParametricPlot3D, etc.\n
The delay before interactive window closes equal approximately 60 seconds. \n
Example: Plot3D[Sin[x y], {x,0,1},{y,0,1}]//ViewPointSelect\n
This function can be used also directly via menu command or by keyboard shortcut Ctrl-Command(Alt)-v. \n
To activate it select the plot function (e.g. Plot3D[...]) or place coursor at the end of expression and press keyboard shortcut."

ViewPointSelectDialog::"usage"=
  "This is function to support ViewPointSelect by menu command"

CopyToClipboard::"usage"=
  "Option of ViewPointSelect, CopyToClipboard->True will sets the option ViewPoint to be automatically copied to clipboard after the selection by function ViewPointSelect."

$PlotFunctions::"usage"="$PlotFunctions is a list of 3D plot functions which can be entered as arguments of ViewPointSelect. This list can be expanded by user-defined functions generating SurfaceGraphics or Graphics3D object. Note, the function Show is treated differently and must not be included into $PlotFunctions"
\


$PlotFunctions={Plot3D,ListPlot3D,ParametricPlot3D}

Begin["`Private`"]



ViewPointSelect::"obj"=
  "The argument of ViewPointSelect must be object SurfaceGraphics or Graphics3D"

ViewPointSelect::"primitives"="Graphics3D consists of unknown primitives"

prims={Cuboid,Line,Point,Polygon,Text,AbsoluteDashing,
      AbsoluteThickness,AbsolutePointSize,CMYKColor,Dashing,EdgeForm,
      FaceForm,
      GrayLevel,Hue,PointSize,RGBColor,SurfaceColor,Thickness};

rescaleGraphics3D[gr_Graphics3D]:=
  Module[{coords,graph,pl,d,bx,xlim,ylim,zlim,f},
    
    graph=First[gr];
    If[Head[graph]=!=List,graph={graph}];
    If[Length[gr]>1,opts=Rest[List@@gr],opts={}];
    
    pl=Show[gr,DisplayFunction\[Rule]Identity];
    rt=AbsoluteOptions[pl,BoxRatios][[1,-1]];
    
    d=Max[rt]/2;
    bx={Line[{{d,d,d},{-d,d,d},{-d,-d,d},{d,-d,d},{d,d,d}}],
        Line[{{d,d,-d},{-d,d,-d},{-d,-d,-d},{d,-d,-d},{d,d,-d}}],
        Line[{{d,d,d},{d,d,-d}}],Line[{{-d,d,d},{-d,d,-d}}],
        Line[{{d,-d,d},{d,-d,-d}}],Line[{{-d,-d,d},{-d,-d,-d}}]};
    bx={Point[{d,d,d}],Point[{-d,d,d}],Point[{d,-d,d}],Point[{-d,-d,d}],
        Point[{d,d,-d}],Point[{-d,d,-d}],Point[{d,-d,-d}],Point[{-d,-d,-d}]};
    
    coords=Sequence@@@
        {Cases[gr,Line[{x__List}]\[RuleDelayed]x,\[Infinity]],
          Cases[gr,Point[x_List]\[RuleDelayed]x,\[Infinity]],
          
          Sequence@@
            Cases[gr,Cuboid[x_List]\[RuleDelayed]{x,x+1},\[Infinity]],
          
          Sequence@@
            Cases[gr,Cuboid[x_List,y_List]\[RuleDelayed]{x,y},\[Infinity]],
          Cases[graph,Polygon[{x__List}]\[RuleDelayed]x,\[Infinity]]};
    {xlim,ylim,zlim}=({Min[#],Max[#]}&/@Transpose[coords])/rt;
    {xlim,ylim,zlim}=If[TrueQ[Equal@@#],#+0.001d{-1,1},#]&/@{xlim,ylim,zlim};
    
    f[{x_,y_,z_}]:={Rescale[x,xlim,{-1,1}/2],Rescale[y,ylim,{-1,1}/2],
        Rescale[z,zlim,{-1,1}/2]};
    graph=
      graph/.{Line[x_List]\[RuleDelayed]Line[f/@x],
          Polygon[x_List]\[RuleDelayed]Polygon[f/@x],
          Point[x_List]\[RuleDelayed]Point[f[x]],
          Cuboid[x_List]\[RuleDelayed]Cuboid[f[x],f[x+1]],
          Cuboid[x_List,y_List]\[RuleDelayed]Cuboid[f[x],f[y]]};
    Graphics3D@@Join[{Prepend[graph,bx]},opts]]

grcell[pl_]:=
  Module[{gr,gropts,h},
    gr=Block[{$DisplayFunction=Identity},pl];
    h=Head[gr];
    If[!MemberQ[{SurfaceGraphics,Graphics3D},h],
      Message[ViewPointSelect::"obj"];Abort[]];
    gropts=Switch[gr,
        (SurfaceGraphics|Graphics3D)[a_List,{opt___?OptionQ}],Last[gr],
        (SurfaceGraphics|Graphics3D)[a_List,opt___?OptionQ],List@@Rest[gr],
        _,{}];
    gropts=
      Cases[gropts,
        Rule[Boxed,_]|Rule[Lighting,_]|Rule[BoxRatios,_]|Rule[Mesh,_]|
          Rule[SphericalRegion,_]];
    If[h===Graphics3D,gr=rescaleGraphics3D[gr]];
    Cell[BoxData[h[First@gr,Sequence@@gropts]],"Graphics"]]

Attributes[grcell]=HoldAll;

xcl:=Cell[BoxData@ButtonBox[RowBox[{
              StyleBox["Copy ViewPoint to clipboard "],
              FrameBox[StyleBox["X",
                  
                  ShowContents\[Rule](CopyToClipboard/.Options[
                          ViewPointSelect])]]}],
          ButtonFrame\[Rule]None,
          ButtonData:>"Clipboard"],
      TextAlignment\[Rule]1,
      FontSize\[Rule]10,
      FontWeight\[Rule]"Bold",
      FontFamily\[Rule]"Helvetica",
      CellMargins\[Rule]{{10,10},{0,5}},
      CellTags\[Rule]"Clipboard"];

bbo={Active\[Rule]True,
    ButtonFrame\[Rule]"DialogBox",
    ButtonFunction\[RuleDelayed](FrontEndExecute[{
              FrontEnd`SetOptions[FrontEnd`ButtonNotebook[],
                
                ButtonBoxOptions\[Rule]{ButtonData:>#, 
                    Active\[Rule]False}]}]&)}

menuCommandQ=False;

ViewPointSelectNotebook[cl_Cell,opts__]:=
  Notebook[{xcl,cl,
      Cell[BoxData@
          GridBox[{{
                If[menuCommandQ,
                  ButtonBox["Copy",ButtonData:>"Copy"],
                  ButtonBox["ViewPoint",ButtonData:>"Copy"]],
                "",
                ButtonBox["Ok",ButtonData:>"Accept"],
                ButtonBox["  Cancel  ",ButtonData:>"Cancel"]}},
            ColumnWidths\[Rule]{8,5,6,6}],
        TextAlignment\[Rule]"Right",
        CellFrame\[Rule]{{0,0},{0,1}},
        CellMargins\[Rule]{{10,10},{0,0}},
        CellLabel\[Rule]"Use Mouse to Rotate the Graphics"]},
    Saveable\[Rule]False,
    ShowCellBracket\[Rule]False,
    WindowElements\[Rule]{"StatusArea","VerticalScrollBar","MenuBar"},
    WindowTitle\[Rule]"ViewPointSelect Window",
    ScrollingOptions\[Rule]{"VerticalScrollRange"\[Rule]Fit},
    ButtonBoxOptions\[Rule]bbo,opts]

ViewPointSelect[pl_]:=
  Module[{nb,nbopts,vp,delay,starttime,interactiveQ=True,action="Cancel",tmp,
      flag=False,imgsz},
    delay=60;
    nb=NotebookPut@ViewPointSelectNotebook[grcell[pl],Visible\[Rule]False];
    NotebookFind[nb,"Graphics",All,CellStyle];
    imgsz=ImageSize/.AbsoluteOptions[NotebookSelection[nb],ImageSize];
    NotebookClose[nb];
    starttime = SessionTime[];
    nb=NotebookPut@
        ViewPointSelectNotebook[grcell[pl],WindowSize\[Rule]imgsz+{100,100}];
    While[
      FreeQ[{$Failed,{}},nbopts=Options[nb],1],
      If[SessionTime[]-starttime>delay,
        FrontEndExecute[{FrontEnd`NotebookClose[nb]}]];
      vp=Cases[NotebookGet[nb],Rule[ViewPoint,a_]\[Rule]a,\[Infinity]];
      If[interactiveQ&&vp=!={},interactiveQ=False;delay=\[Infinity]];
      If[MatchQ[ButtonBoxOptions/.nbopts,_?OptionQ|{___?OptionQ}]&&
          Not[Active/.(ButtonBoxOptions/.nbopts)],
        tmp=ButtonData/.(ButtonBoxOptions/.nbopts);
        If[tmp==="Clipboard",
          SetOptions[nb,ButtonBoxOptions\[Rule]bbo];
          SetOptions[ViewPointSelect,CopyToClipboard\[Rule]
              Not[CopyToClipboard/.Options[ViewPointSelect]]];
          NotebookFind[nb,"Clipboard",All,CellTags,AutoScroll\[Rule]False];
          NotebookWrite[nb,xcl,None],
          If[MatchQ[tmp,"Accept"|"Copy"],flag=True;action=tmp];
          vp=Cases[NotebookGet[nb],Rule[ViewPoint,a_]\[Rule]a,\[Infinity]];
          FrontEndExecute[{FrontEnd`NotebookClose[nb]}]]]];
    
    If[flag&&MatchQ[vp,{{_Real,_Real,_Real}}],
      vp=First[vp];
      If[TrueQ[CopyToClipboard/.Options[ViewPointSelect]],
        vpToClipboard[vp]];
      If[menuCommandQ,
        menuCommandQ=False;
        Switch[action,
          "Accept",insertViewPoint[vp],
          "Copy",vpToClipboard[vp];
          SelectionMove[InputNotebook[],After,Character]],
        Switch[action,
          "Accept",Append[Unevaluated[pl],ViewPoint\[Rule]vp],
          "Copy",ViewPoint\[Rule]vp]],
      
      If[menuCommandQ,menuCommandQ=False;
        SelectionMove[InputNotebook[],After,Character],pl]]]

Options[ViewPointSelect]=CopyToClipboard\[Rule]False;
Attributes[ViewPointSelect]={Protected,ReadProtected,HoldAll};

vpToClipboard[vp_]:=
  Module[{},
    (* This opens the ClipboardNotebook[] if it has not been open *)
    FrontEndTokenExecute["Copy"];
    SelectionMove[ClipboardNotebook[],All,Notebook];
    NotebookWrite[ClipboardNotebook[],
      Cell[BoxData[
          ToBoxes[ViewPoint\[Rule]InputForm[N[Round[1000*vp]/1000]]]]]]]

getExpr[nb_]:=
  Module[{sel},
    sel=NotebookRead[nb];
    If[sel==={},
      SelectionMove[nb,All,Word];
      sel=NotebookRead[nb];
      If[sel=!={},
        FrontEndTokenExecute["ExpandSelection"];
        sel=NotebookRead[nb]]];
    If[Head[sel]===Cell,SelectionMove[nb,After,Cell]];
    If[Head[sel]===BoxData,
      Block[{Message},SetAttributes[Message,HoldAll];
        sel=ToExpression[First[sel],StandardForm,HoldForm]];
      If[sel=!=$Failed,
        If[Head[sel]===HoldForm,sel={sel}];
        If[MatchQ[sel,
              {HoldForm@@{Alternatives@@(Blank/@$PlotFunctions)}}]||
            (sel[[1,1,0]]===Show&&
                MatchQ[sel[[1,1,1]],_Graphics3D|{_Graphics3D}]),
          First[sel],$Failed]],$Failed]]

ViewPointSelectDialog[]:=
  Module[{sel,h},
    menuCommandQ=False;
    sel=getExpr[InputNotebook[]];
    If[sel===$Failed,
      SelectionMove[InputNotebook[],After,Character],
      menuCommandQ=True;
      ViewPointSelect@@sel]];

insertViewPoint[vp_]:=
  Module[{sel,h},
    sel=getExpr[InputNotebook[]];
    If[sel=!=$Failed,
      sel=Insert[sel,ViewPoint\[Rule]N[Round[1000vp]/1000],{1,-1}];
      Block[{Graphics3D},sel=ToBoxes[sel][[1]]];
      sel=sel/.s_String\[RuleDelayed]StringReplace[s,
              
              a:(StartOfString~~
                      DigitCharacter...~~
                        "."~~DigitCharacter...~~
                            "`"~~EndOfString)\[RuleDelayed]StringDrop[a,-1]];
      NotebookWrite[InputNotebook[],sel,After]]];



End[];
EndPackage[]



















